searchNodes=[{"doc":"Creates a shell script for invoking ssh to upgrade devices with ssh_subsystem_fwup.This script may be used on its own or used as a base for more complicated device software upgrade deployments.It saves the script to upload.sh.","ref":"Mix.Tasks.Firmware.Gen.Script.html","title":"Mix.Tasks.Firmware.Gen.Script","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Firmware.Gen.Script.html#run/1","title":"Mix.Tasks.Firmware.Gen.Script.run/1","type":"function"},{"doc":"Upgrade the firmware on a Nerves device using SSH.By default, mix upload reads the firmware built by the current MIX_ENV and MIX_TARGET settings, and sends it to nerves.local. Pass in a another hostname to send the firmware elsewhere.NOTE: This implementation cannot ask for passphrases, and therefore, cannot connect to devices protected by username/passwords or decrypt password-protected private keys. One workaround is to use the ssh-agent to pass credentials.Command line options--firmware - The path to a fw fileExamplesUpgrade a Raspberry Pi Zero at nerves.local:MIX_TARGET=rpi0 mix upload nerves.localUpgrade 192.168.1.120 and explicitly pass the .fw file:mix upload 192.168.1.120 --firmware _build/rpi0_prod/nerves/images/app.fw","ref":"Mix.Tasks.Upload.html","title":"Mix.Tasks.Upload","type":"task"},{"doc":"SSH subsystem for upgrading Nerves devicesThis module provides an SSH subsystem for Erlang's ssh application. This makes it possible to send firmware updates to Nerves devices using plain old ssh like this:cat $firmware | ssh -s $ip_address fwupWhere $ip_address is the IP address of your Nerves device. Depending on how you have Erlang's ssh application set up, you may need to pass more parameters (like username, port, identities, etc.).See nerves_ssh for an easy way to set this up. If you don't want to use nerves_ssh, then in your call to :ssh.daemon add the return value from SSHSubsystemFwup.subsystem_spec/1:devpath = Nerves.Runtime.KV.get(&quot;nerves_fw_devpath&quot;) :ssh.daemon([ {:subsystems, [SSHSubsystemFwup.subsystem_spec(devpath: devpath)]} ])See SSHSubsystemFwup.subsystem_spec/1 for options. You will almost always need to pass the path to the device that should be updated since that is device-specific.","ref":"SSHSubsystemFwup.html","title":"SSHSubsystemFwup","type":"module"},{"doc":"Helper for creating the SSH subsystem spec","ref":"SSHSubsystemFwup.html#subsystem_spec/1","title":"SSHSubsystemFwup.subsystem_spec/1","type":"function"},{"doc":"Options::devpath - path for fwup to upgrade (Required):fwup_path - path to the fwup firmware update utility:fwup_extra_options - additional options to pass to fwup like for setting public keys:success_callback - an MFA to call when a firmware update completes successfully. Defaults to {Nerves.Runtime, :reboot, []}.:task - the task to run in the firmware update. Defaults to &quot;upgrade&quot;","ref":"SSHSubsystemFwup.html#t:options/0","title":"SSHSubsystemFwup.options/0","type":"type"},{"doc":"SSHSubsystemFwup This library provides an ssh subsystem that applies Nerves &quot;over-the-air&quot; firmware updates. It is an alternative to nerves_firmware_ssh that extracts the update service to a :ssh.daemon/1 spec. This trims down the responsibilities of the library and makes it possible to:Customize ssh authentication (for example, password-based auth is possible)Handle host keys differently and more securelyRun firmware updates on port 22 with other ssh servicesIn addition, the protocol for sending updates over ssh has been simplified. If you're coming from nerves_firmware_ssh, you'll have used the upload.sh script or mix upload. This library provides the same interface. If using upload.sh, you will need to rerun mix firmware.gen.script since the script has changed.","ref":"readme.html","title":"SSHSubsystemFwup","type":"extras"},{"doc":"The easiest installation is to use nerves_ssh and have it bring in this library as a dependency. See that project for details.However, if you do not want to use nerves_ssh, here's what do do. First, add the dependency:def deps do [{:ssh_subsystem_fwup, &quot;~&gt; 0.5.0&quot;}] endThen add ssh subsystem spec to the call that starts the ssh daemon. This code will look something like: {:ok, ref} = :ssh.daemon([ {:subsystems, [SSHSubsystemFwup.subsystem_spec()]} ])You will likely have many more options passed to the ssh.daemon.","ref":"readme.html#installation","title":"SSHSubsystemFwup - Installation","type":"extras"},{"doc":"There are two ways of uploading firmware. The first is to run:mix uploadThat doesn't work for everyone due to ssh authentication preferences. The alternative is to use commandline ssh. For convenience, ssh_subsystem_fwup can generate a script that makes this easier. Go to your Nerves project directory and run:mix firmware.gen.scriptThis should create an upload.sh script. Frequently when starting out, you can run ./upload.sh without arguments since it will guess that it's supposed to upload to nerves.local. To specify a device to upload to, pass the device's hostname as the first argument. For example:$ ./upload.sh nerves-1234.local fwup: Upgrading partition B |====================================| 100% (32.34 / 32.34) MB Success! Elapsed time: 4.720 s Disconnected from 172.31.207.89 port 22Note that the .local address assumes that mDNS has been configured on the device and that mDNS works on your network and OS. That's not always the case and a frequent source of frustration when it fails. When in doubt, check that you can upload to the device's IP address. You can get the IP address from your router or by connecting to the device's IEx prompt and running ifconfig.","ref":"readme.html#uploading-firmware","title":"SSHSubsystemFwup - Uploading firmware","type":"extras"},{"doc":"It's not necessary to use the upload.sh script. The following line is equivalent:cat $firmware | ssh -s $nerves_device fwup","ref":"readme.html#upload-protocol","title":"SSHSubsystemFwup - Upload protocol","type":"extras"},{"doc":"All source code is licensed under the Apache License, 2.0.","ref":"readme.html#license","title":"SSHSubsystemFwup - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Initial release.This factors out the SSH subsystem from nerves_firmware_ssh and removes all ssh server code. The user of this library now has to start a server themselves. This makes it possible to run the firmware update on port 22 and removes the constraint of needing to hard code authorized ssh public keys.","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"}]